IF Exists (Select 1 From Sys.objects Where Name = 'reportdata_Compliance_Percentage' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportdata_Compliance_Percentage]
GO

CREATE PROC [dbo].[reportdata_Compliance_Percentage]-- 9503
( 
	@A_OBJECT_ID INT
)
AS
BEGIN
	--Declare @A_OBJECT_ID Int = 9528
	Select OBJ_ID INTO #OBJ From Object Where OBJ_ASPECT_LINK = @A_OBJECT_ID

	Declare @AttType_Impact_Type Int
	Declare @AttributeType_Control Int
	Declare @AttributeType_DomainType_Name Int
	Declare @AttributeType_DomainName Int
	Declare @TOTAL_CONTROLS_WITHOUT_GAPS  Int
	Declare @TOTAL_CONTROLS_IN_DOMAIN  Int

	Declare @FindingType_ID_Gap Int
	Declare @CategoryType_ID_Gap Int
	Declare @TotalQuestion Int
	Declare @GapRecord Int
	Select @FindingType_ID_Gap = FINDINGTYPE_ID FROM FI_FINDINGTYPE WHERE FINDINGTYPE_RSAM_ID = 'RSAM-00001'

	Select @CategoryType_ID_Gap = CATEGORYTYPE_ID FROM FI_CATEGORYTYPE WHERE CATEGORYTYPE_RSAM_ID = 'RSAM-00001'
	--Select @TotalQuestion,@GapRecord
	Select @AttType_Impact_Type = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = 'RSAM-AS003' --Question Impact Type
	Select @AttributeType_Control = ATT_ID From ATTRIBUTE Where ATT_RSAM_ID = 'ASAT-00008' -- Control 

	Select @AttributeType_DomainType_Name = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = 'RSAM-AS019' -- DomainTYpe Name
	Select @AttributeType_DomainName = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = 'RSAM-AS020' -- Domain Name
	
	Create Table #WithGap (ConType_ID Int)
	Create Table #WithoutGap (ConType_ID Int)
	Create Table #UnAnswered (ConType_ID Int)
	--To get the DomainType Name and ID
	Select CONCLASSTYPE_ID, ATTRIBUTE_DATA CONCLASSTYPE_NAME
	INTO #DomainType 
	From FI_FINDING
	JOIN FI_FINDINGTYPE ON FINDINGTYPE_ID = FINDINGTYPE_ID_R And FINDINGTYPE_USETYPE = 28
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R And ATTTYPE_ID_R = @AttributeType_DomainType_Name
	JOIN CONTROLCLASSTYPE ON CONTROLCLASSTYPE.FINDING_ID_R = FINDING_ID

	--To get the Domain Name and ID
	Select CONCLASS_ID, ATTRIBUTE_DATA CONCLASS_NAME ,CONCLASSTYPE_ID_R
	INTO #Domain
	From FI_FINDING
	JOIN FI_FINDINGTYPE ON FINDINGTYPE_ID = FINDINGTYPE_ID_R And FINDINGTYPE_USETYPE = 29
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R And ATTTYPE_ID_R  = @AttributeType_DomainName
	JOIN CONTROLCLASS ON CONTROLCLASS.FINDING_ID_R = FINDING_ID

	Select ORIGINATION_FINDING_ID_R -- This is the FIndingID For Original Question
	INTO #QUESTION
	From FI_FINDING
	JOIN FI_FINDINGTYPE ON FINDINGTYPE_ID_R = FINDINGTYPE_ID AND FINDINGTYPE_USETYPE = 26
	JOIN FI_FINDING_ATTRIBUTE ON ORIGINATION_FINDING_ID_R = FINDING_ID_R AND ATTTYPE_ID_R = @AttType_Impact_Type AND ATTRIBUTE_ID_R = @AttributeType_Control
	JOIN #OBJ On OBJ_ID = OBJ_ID_R


--All Controls related to the Object And its Aspect
--Total ControlType Related to the Objec and its Aspect
Select  CONTYPE_ID
INTO #TotalControlType
	From CONTROLTYPE
	JOIN  (Select ORIGINATION_FINDING_ID_R -- This is the FIndingID For Original Question
	From FI_FINDING
	JOIN FI_FINDINGTYPE ON FINDINGTYPE_ID_R = FINDINGTYPE_ID AND FINDINGTYPE_USETYPE = 26
	JOIN FI_FINDING_ATTRIBUTE ON ORIGINATION_FINDING_ID_R = FINDING_ID_R AND ATTTYPE_ID_R = @AttType_Impact_Type AND ATTRIBUTE_ID_R = @AttributeType_Control
	JOIN #OBJ On OBJ_ID = OBJ_ID_R ) A On A.ORIGINATION_FINDING_ID_R = CONTROLTYPE.FINDING_ID_R --and CONCLASSTYPE_ID=6
	JOIN #QUESTION Q On Q.ORIGINATION_FINDING_ID_R = CONTROLTYPE.FINDING_ID_R

	--Gap Record ControlType
	Select Distinct FI_FINDING.CONTYPE_ID_R 
	INTO #GapControlType
	From FI_FINDING
	JOIN #OBJ On OBJ_ID = OBJ_ID_R
	Where FINDINGTYPE_ID_R = @FindingType_ID_Gap And CATEGORYTYPE_ID_R = @CategoryType_ID_Gap
	--Answered Record
	Select Distinct CONTROL.CONTYPE_ID_R 
	INTO #AnsweredControlType
	From OBJECT_CONTROL
	JOIN CONTROL ON CON_ID = CON_ID_R
	JOIN #OBJ On OBJ_ID = OBJ_ID_R
	
	--UnAnswered
	Insert Into #UnAnswered
	Select CONTYPE_ID From #TotalControlType
	Except 
	Select CONTYPE_ID_R From #AnsweredControlType

	--Without Gap
	Insert Into #WithoutGap
	Select CONTYPE_ID_R From #AnsweredControlType
	Except 
	Select ConType_ID_R From #GapControlType

	-- Gap Record
	Insert Into #WithGap
	Select * From #GapControlType

	Select CONCLASS_ID,CONCLASS_NAME,CONCLASSTYPE_ID,CONCLASSTYPE_NAME,
	CONCLASS_ID Unanswered_Total,0 As WithGap_Total, 0 As WithoutGap_Total
	From 
	#UnAnswered
	JOIN CONTROLTYPE_CONTROLCLASS ON #UnAnswered.CONTYPE_ID = CONTROLTYPE_CONTROLCLASS.CONTYPE_ID_R
	JOIN #Domain CONTROLCLASS ON CONCLASS_ID = CONTROLTYPE_CONTROLCLASS.CONCLASS_ID_R
	JOIN #DomainType CONTROLCLASSTYPE ON CONTROLCLASSTYPE.CONCLASSTYPE_ID = CONCLASSTYPE_ID_R
	Union All
	Select CONCLASS_ID,CONCLASS_NAME,CONCLASSTYPE_ID,CONCLASSTYPE_NAME,
	0 AS Unanswered_Total,CONCLASS_ID WithGap_Total,0 As WithoutGap_Total
	 From 
	#WithGap
	JOIN CONTROLTYPE_CONTROLCLASS ON #WithGap.ConType_ID = CONTROLTYPE_CONTROLCLASS.CONTYPE_ID_R
	JOIN #Domain CONTROLCLASS ON CONCLASS_ID = CONTROLTYPE_CONTROLCLASS.CONCLASS_ID_R
	JOIN #DomainType CONTROLCLASSTYPE ON CONTROLCLASSTYPE.CONCLASSTYPE_ID = CONCLASSTYPE_ID_R
	
	Union All
	Select CONCLASS_ID,CONCLASS_NAME,CONCLASSTYPE_ID,CONCLASSTYPE_NAME,
	0 AS Unanswered_Total,0 As WithGap_Total,CONCLASS_ID WithoutGap_Total
	From 
	#WithoutGap
	JOIN CONTROLTYPE_CONTROLCLASS ON #WithoutGap.ConType_ID = CONTROLTYPE_CONTROLCLASS.CONTYPE_ID_R
	JOIN #Domain CONTROLCLASS ON CONCLASS_ID = CONTROLTYPE_CONTROLCLASS.CONCLASS_ID_R
	JOIN #DomainType CONTROLCLASSTYPE ON CONTROLCLASSTYPE.CONCLASSTYPE_ID = CONCLASSTYPE_ID_R
	
	Drop Table #OBJ
	Drop Table #Domain
	Drop Table #DomainType
	Drop Table #QUESTION
	Drop Table #AnsweredControlType
	Drop Table #GapControlType
	Drop Table #TotalControlType
	Drop Table #UnAnswered
	Drop Table #WithGap
	Drop Table #WithoutGap

END

GO 
GRANT EXEC ON reportdata_Compliance_Percentage TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'reportdata_Compliance_Percentage_Multiple' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportdata_Compliance_Percentage_Multiple]
GO

CREATE PROC [dbo].[reportdata_Compliance_Percentage_Multiple]
(@i_iObjectID VARCHAR(MAX))
AS

Declare @Count Int=1, @Total Int, @Obj_ID int

Select Position, Int_Value INTO #Temp From dbo.FnConvertStrToArray(@i_iObjectID,',')
Set @Total = @@ROWCOUNT

CREATE TABLE #TOTAL_CONTROL_Count (CONCLASS_ID Int,CONCLASS_NAME NVARCHAR(MAX),CONCLASSTYPE_ID INT,CONCLASSTYPE_NAME nVARCHAR(MAX),Unanswered_Total Int,WithGap_Total Int,WithoutGap_Total Int)
While @Count <= @Total
BEGIN
	Select @Obj_ID = Int_Value From #Temp Where Position = @Count
	Insert Into #TOTAL_CONTROL_Count
	Exec reportdata_Compliance_Percentage @Obj_ID
	Set @Count = @Count + 1
END

Select CONCLASS_ID,CONCLASSTYPE_ID,CONCLASSTYPE_NAME,CONCLASS_NAME,Sum(Unanswered_Total) Unanswered_Total,Sum(WithoutGap_Total) WithoutGap_Total,Sum(WithGap_Total) WithGap_Total
,Dense_Rank() Over (Partition By CONCLASSTYPE_ID Order By CONCLASS_ID) ConID , 
	Dense_Rank() Over (Order By CONCLASSTYPE_ID ) ConTypeID 
From #TOTAL_CONTROL_Count
Group By CONCLASS_ID,CONCLASSTYPE_ID,CONCLASSTYPE_NAME,CONCLASS_NAME

drop table #TOTAL_CONTROL_Count

GO 
GRANT EXEC ON reportdata_Compliance_Percentage_Multiple TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'reportdata_object_objectdetail_SSRS' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportdata_object_objectdetail_SSRS]
GO

CREATE PROCEDURE [dbo].[reportdata_object_objectdetail_SSRS](                        
 @ItemID bigint,                       
 @OBJTYPE_ID int = NULL ,
 @mode char(1)        
)                        
AS                      
BEGIN                      
 SET NOCOUNT ON;
 Declare @RMTYPE Int=0,@CTypeSQL Int = 0,@rlkey Int=0,@rtypekey Int=0,@containertypekey Int=10,@remscores Int=0,@RptID Int=100204

 if @rlkey = 0                         
  set @rlkey =null                        
 if @rtypekey =0                         
  set @rtypekey =null                      
                
 declare @ContainerType varchar(10)                    
 IF @containertypekey =0                   
  set @ContainerType =@containertypekey                  
 IF @containertypekey =7                   
  set @ContainerType =3                  
 IF @containertypekey =6                   
  set @ContainerType ='4,5,6'                  
 IF @containertypekey =10               
  set @containertypekey=null              
              
  --To run reports based on Aspect objects    
  declare @obj_Aspect_link int    
  declare @OldItemID int 
  Declare @iVendorType_ObjType_ID INt
  
  Select @iVendorType_ObjType_ID = OBJTYPE_ID From Objecttype Where objtype_rsam_Id = 'RSAM-00114'
      
  set @OldItemID = @ItemID    
  set @obj_Aspect_link=(select obj_aspect_link from object where obj_id=@ItemID)          
    
  --Assign the main object ID to the Aspect object
  if @mode='O'
  	BEGIN  
  		if @obj_Aspect_link <> @ItemID    
 			BEGIN    
  				set @ItemID=@obj_Aspect_link    
 			END         
  	END
Create Table #AllObject (All_OBJ_ID INT)
-- If ObjectTYpe is provided
IF @OBJTYPE_ID IS NOT NULL
BEGIN
	Insert INTO #AllObject 
	Select O1.OBJ_ID
		From Object O
		JOIN Object O1 On O.OBJ_ID = O1.OBJ_ASPECT_LINK
		where o.OBJTYPE_ID_R = @iVendorType_ObjType_ID
END
ELSE
BEGIN
	Insert INTO #AllObject 
	Select O1.OBJ_ID  
		From Object O
		JOIN Object O1 On O.OBJ_ID = O1.OBJ_ASPECT_LINK
END

  CREATE TABLE #TmpObjFilter(ID INT IDENTITY,OBJ_ID int,             
  OBJ_NAME nvarchar(500),OBJ_DESC nvarchar(max), OBJTYPE_ID_R int,OBJ_GROUP_R int,            
  OBJ_INOTES nvarchar(max), OBJ_RNOTES nvarchar(max),OBJ_AUDITCOMP bit,            
  OBJ_REVIEWCOMP bit, OBJ_LOCKED bit,OBJ_DOE smalldatetime,            
  OBJ_EB nvarchar(500),OBJ_DOU datetime,            
  OBJ_UB nvarchar(500), OBJ_GROUP_LINK int,OBJ_ASPECT_LINK int,            
  OBJ_WF_STATE_ID_R int,OBJ_CYCLE_DATE datetime,ASPECT_CONTAINERTYPE int,            
  WF_STATE_NAME nvarchar(500),WF_STATE_EXCLUDE_FROM_REPORTS int,            
  WF_STATE_VIEW_RISKMANAGEMENT int,ASPECT_OBJTYPE_ID int)                                         
               
   
 INSERT INTO #TmpObjFilter SELECT OBJ_ID,OBJ_NAME,OBJ_DESC,                                            
  OBJTYPE_ID_R,OBJ_GROUP_R,OBJ_INOTES,OBJ_RNOTES,                                            
  OBJ_AUDITCOMP,OBJ_REVIEWCOMP,OBJ_LOCKED,                                            
  OBJ_DOE,OBJ_EB,OBJ_DOU,OBJ_UB,OBJ_GROUP_LINK,                                            
  OBJ_ASPECT_LINK,OBJ_WF_STATE_ID_R,OBJ_CYCLE_DATE,ASPECT_CONTAINERTYPE,                
  WF_STATE_NAME,WF_STATE_EXCLUDE_FROM_REPORTS,WF_STATE_VIEW_RISKMANAGEMENT,                
  ASPECT_OBJTYPE_ID                   
  FROM dbo.fn_OBJECT_FILTER(@mode,@CTypeSQL,@Itemid,@RptID,0) 
  JOIN #AllObject ON All_OBJ_ID = OBJ_ID                
                    
                                      
 --Temp table for Container filter                  
                   
  CREATE TABLE #TmpObjContainer(OBJ_CONTAINER_ID int,OBJ_ID_R int,OBJ_CONTAINER_ID_R int)                                            
  INSERT INTO #TmpObjContainer SELECT OBJ_CONTAINER_ID,OBJ_ID_R,OBJ_CONTAINER_ID_R                  
  FROM dbo.fn_ObjectContainer(@mode,@Itemid)                         
  Declare @Count Int = 1, @Total Int = 0  , @Item_ID_New Int        
  Select @Total = Count(OBJ_ID) From #TmpObjFilter
                        
 CREATE TABLE #R_Object_Score          
 (OBJ_ID int,SumOfEVAL_Sec real,OBJ_ROOMVIOLATION real,Obj_Total_Score real,                                            
  Obj_Total_Control_Score real,OBJTYPE_ID_R int,OBJ_GROUP_R int,Obj_Some_Violation_Count int)          

IF @mode = 'O'
	EXECUTE reportdata_object_score @RMTYPE,@mode,@CTypeSQL,@ItemID,@rlkey,@rtypekey,@remscores,@containertypekey,@RptID          
ELSE --IF @mode = 'S' then looping reportdata_object_score for each object in the scope
BEGIN
While @Total >= @Count
	BEGIN
		Select @Item_ID_New = OBJ_ID From #TmpObjFilter Where ID = @Count
		EXECUTE reportdata_object_score @RMTYPE,'O',@CTypeSQL,@Item_ID_New,@rlkey,@rtypekey,@remscores,@containertypekey,@RptID          
		Set @Count = @Count + 1
	END 
END
 --Final Query for R_Report_Object                      
	SELECT #TmpObjFilter.OBJ_ID,#TmpObjFilter.OBJ_NAME,
	#TmpObjFilter.OBJTYPE_ID_R,
	#R_Object_Score.SumOfEVAL_Sec,
	#R_Object_Score.Obj_Total_Score,
	#R_Object_Score.Obj_Total_Control_Score
	FROM 
	OBJECTTYPE
	INNER JOIN #TmpObjFilter ON #TmpObjFilter.OBJTYPE_ID_R = OBJECTTYPE.OBJTYPE_ID
	INNER JOIN #R_Object_Score ON #TmpObjFilter.OBJ_ID = #R_Object_Score.OBJ_ID                       
	WHERE (((#TmpObjFilter.ASPECT_CONTAINERTYPE)<>3))  
	AND (#TmpObjFilter.OBJ_ID =
	(case WHEN  (@mode <>'O') THEN #TmpObjFilter.OBJ_ID 
	WHEN  (@mode ='O' and @ItemID = @obj_Aspect_link) THEN #TmpObjFilter.OBJ_ID    
	ELSE  @ItemID            
	END))               
	ORDER BY #R_Object_Score.Obj_Total_Score                        
	                
END

GO 
GRANT EXEC ON reportdata_object_objectdetail_SSRS TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'reportdata_ObjectSummary' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportdata_ObjectSummary]
GO
CREATE PROC reportdata_ObjectSummary --9503
(
	@i_iObjectID INT
)
AS
DECLARE @ATT_TYPE_ID_DESC INT, @ATT_TYPE_ID_AREAUSEDBY INT
SELECT @ATT_TYPE_ID_DESC = ATT_TYPE_ID FROM ATTRIBUTETYPE WHERE ATTTYPE_RSAM_ID = 'RSAM01-00000778-004AAA475DF141E09524D100CA7FF6F7' --Description
SELECT @ATT_TYPE_ID_AREAUSEDBY = ATT_TYPE_ID FROM ATTRIBUTETYPE WHERE ATTTYPE_RSAM_ID = 'RSAM01-00000780-430921E1FE494E65BE3B2DA9A7A13EFC' --Areas Used By
Select OBJ_ID, OBJ_NAME,WF_STATE_NAME,ATTTYPE_NAME,OBJTYPE_NAME,ISNULL(Att_Data,'No Data') Att_Data,TextColor From (

SELECT Distinct OBJ_ID, OBJ_NAME,WF_STATE_NAME,ATT.ATTTYPE_NAME,OBJTYPE_NAME,
Case When WF_STATE_RSAM_ID IN('RSAM-00029','SAND01-00000099-A749D17C922A441BAF7508A97F499B0A') THen '#3e3e40' Else 'Red' End TextColor, 
ATT_DATA = STUFF((Select ', '+ ISNULL(ATT_DATA,ATT_DESC) From OBJECT_ATTRIBUTE 
JOIN ATTRIBUTETYPE On ATT_TYPE_ID = ATTTYPE_ID_R And ATTTYPE_ID_R IN(@ATT_TYPE_ID_DESC, @ATT_TYPE_ID_AREAUSEDBY)
LEFT JOIN ATTRIBUTE On ATTRIBUTE.ATTTYPE_ID_R = ATT_TYPE_ID And ATT_ID_R = ATT_ID
    WHERE ATT_TYPE_ID = ATT.ATT_TYPE_ID AND OBJ_ID_R = @i_iObjectID
    FOR XML PATH(''), TYPE).value('.[1]', 'nvarchar(max)'), 1, 1, '')
From  Object 
JOIN OBJECTTYPE ON OBJTYPE_ID = OBJTYPE_ID_R
Join SYS_WF_STATE ON WF_STATE_ID = OBJ_WF_STATE_ID_R
LEFT JOIN OBJECT_ATTRIBUTE On OBJ_ID = OBJ_ID_R And ATTTYPE_ID_R IN(@ATT_TYPE_ID_DESC, @ATT_TYPE_ID_AREAUSEDBY)
LEFT JOIN ATTRIBUTETYPE ATT On ATT_TYPE_ID = ATTTYPE_ID_R
Where OBJ_ID = @i_iObjectID) MID


GO 
GRANT EXEC ON reportdata_ObjectSummary TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'reportdata_QS_FINDING_BURNDOWN_COMPLIANCE_DOMAINTYPE' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportdata_QS_FINDING_BURNDOWN_COMPLIANCE_DOMAINTYPE]
GO
CREATE PROC [dbo].[reportdata_QS_FINDING_BURNDOWN_COMPLIANCE_DOMAINTYPE] --9503, 6
(
@i_sObjectID Varchar(Max),
@CONCLASSTYPE_ID_R Varchar(max),
@i_sUserID Varchar(100),
@i_sSearch_RSAM_ID varchar(50)

)
AS
BEGIN
	Declare 
	--@i_iObjectID Int = 9503,
	--@i_iCONCLASSTYPE_ID_R Int = 18,
	@AttType_RSAM_ID_RequiredClouserDate Varchar(50)= 'RSAM01-00000742-EE4D4019D54049D4B13F22B4BAA1F112',
	@AttType_RSAM_ID_UniversalSeverityRisk Varchar(50) = 'RSAM-00209',
	@AttType_RSAM_ID_DateOpened Varchar(50) = 'RSAM-00620',
	@AttType_RSAM_ID_ActualClouserDate Varchar(50) = 'RSAM01-00000859-5BF437B693464319A207E1DF6833A602',
	@FindingType_RSAM_ID Varchar(50) = 'RSAM-00001',
	@AttType_RSAM_ID_ComplianceDomain Varchar(50) = 'RSAM-00304'

	Declare @AttType_ID_RequiredClouserDate Int,
			@AttType_ID_UniversalSeverityRisk Int,
			@AttType_ID_DateOpened Int,
			@AttType_ID_ComplianceDomain Int,
			@FindingType_ID Int
	Declare @i_SearchID Int
	Select @i_SearchID = Search_ID From Search Where Search_RSAM_ID = @i_sSearch_RSAM_ID

	Select @AttType_ID_RequiredClouserDate = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = @AttType_RSAM_ID_RequiredClouserDate
	Select @AttType_ID_DateOpened = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = @AttType_RSAM_ID_DateOpened
	Select @AttType_ID_UniversalSeverityRisk = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = @AttType_RSAM_ID_UniversalSeverityRisk
	Select @FindingType_ID = FINDINGTYPE_ID FROM FI_FINDINGTYPE WHERE FINDINGTYPE_RSAM_ID = @FindingType_RSAM_ID
	Select @AttType_ID_ComplianceDomain = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = @AttType_RSAM_ID_ComplianceDomain

	Create Table #RClosureDate (FindingID Int, ColName Varchar(100), RCD Date)
	Create Table #USeverityRisk (FindingID Int, ColName Varchar(100), USR Int)
	Create Table #ComplianceDomain (FindingID Int, ColName Varchar(100), Domain Varchar(100))
	Create Table #DateOpen (FindingID Int, ColName Varchar(100), DO Date)
	Select Int_Value INTO #CONCLASSTYPE From dbo.FnConvertStrToArray(@CONCLASSTYPE_ID_R,',')
	
	Declare @AttributeType_DomainType_Name Int
	Declare @AttributeType_DomainName Int
	Select @AttributeType_DomainType_Name = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = 'RSAM-AS019' -- DomainTYpe Name
	Select @AttributeType_DomainName = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = 'RSAM-AS020' -- Domain Name
	Select @FindingType_ID = FINDINGTYPE_ID FROM FI_FINDINGTYPE WHERE FINDINGTYPE_RSAM_ID = @FindingType_RSAM_ID
	Select Int_Value INTO #OBJ From dbo.FnConvertStrToArray(@i_sObjectID,',')

	--To get the DomainType Name and ID
	Select CONCLASSTYPE_ID, ATTRIBUTE_DATA CONCLASSTYPE_NAME
	INTO #DomainType 
	From FI_FINDING
	JOIN FI_FINDINGTYPE ON FINDINGTYPE_ID = FINDINGTYPE_ID_R And FINDINGTYPE_USETYPE = 28
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R And ATTTYPE_ID_R = @AttributeType_DomainType_Name
	JOIN CONTROLCLASSTYPE ON CONTROLCLASSTYPE.FINDING_ID_R = FINDING_ID

	--To get the Domain Name and ID
	Select CONCLASS_ID, ATTRIBUTE_DATA CONCLASS_NAME ,CONCLASSTYPE_ID_R
	INTO #Domain
	From FI_FINDING
	JOIN FI_FINDINGTYPE ON FINDINGTYPE_ID = FINDINGTYPE_ID_R And FINDINGTYPE_USETYPE = 29
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R And ATTTYPE_ID_R  = @AttributeType_DomainName
	JOIN CONTROLCLASS ON CONTROLCLASS.FINDING_ID_R = FINDING_ID
	
	
	--Get the Search Result and Insert into Temp table 
	CREATE TABLE #Search_Mid          
	( Finding_ID int) 
	Insert Into #Search_Mid
	exec RS_SavedSearch @i_iSearchID= @i_SearchID,@i_sUserID = @i_sUserID,@i_bIgnorePermissions=N'0' ,@i_iGetDataOnlyForFirstColumn = 1,@i_sFieldsToDisplay = '' -- Can Filter it with the Current Object
	--Use the Temp table and filter it with the passed Objects
	Select #Search_Mid.*,FINDINGTYPE_ID_R INTO #Search
	From FI_FINDING
	JOIN #Search_Mid ON #Search_Mid.Finding_ID = FI_FINDING.FINDING_ID --And FINDINGTYPE_ID_R = @FindingType_ID
	JOIN #OBJ ON Int_Value = OBJ_ID_R

	Insert Into #USeverityRisk
	Select FINDING_ID, ATTTYPE_NAME, convert(varchar,ATT_WEIGHT) ATTRIBUTE_DATA 
	From #Search FI_FINDING 
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R
	JOIN ATTRIBUTETYPE ON ATT_TYPE_ID = ATTTYPE_ID_R
	LEFT JOIN ATTRIBUTE ON ATT_ID = ATTRIBUTE_ID_R
	Where FINDINGTYPE_ID_R = @FindingType_ID  And FI_FINDING_ATTRIBUTE.ATTTYPE_ID_R = @AttType_ID_UniversalSeverityRisk

	Insert Into #DateOpen
	Select FINDING_ID, ATTTYPE_NAME, ATTRIBUTE_DATE 
	From #Search FI_FINDING 
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R
	JOIN ATTRIBUTETYPE ON ATT_TYPE_ID = ATTTYPE_ID_R
	Where FINDINGTYPE_ID_R = @FindingType_ID  And FI_FINDING_ATTRIBUTE.ATTTYPE_ID_R = @AttType_ID_DateOpened

	Insert Into #RClosureDate
	Select FINDING_ID, ATTTYPE_NAME, ATTRIBUTE_DATE 
	From #Search FI_FINDING 
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R
	JOIN ATTRIBUTETYPE ON ATT_TYPE_ID = ATTTYPE_ID_R
	Where FINDINGTYPE_ID_R = @FindingType_ID  And FI_FINDING_ATTRIBUTE.ATTTYPE_ID_R = @AttType_ID_RequiredClouserDate

	Insert Into #ComplianceDomain
	Select FINDING_ID, ATTTYPE_NAME, CONCLASSTYPE_NAME From 
	#Search FI_FINDING 
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R
	JOIN #Domain ON ATTRIBUTE_TABLE_ID_R = CONCLASS_ID
	JOIN #DomainType ON CONCLASSTYPE_ID = CONCLASSTYPE_ID_R
	JOIN #CONCLASSTYPE ON CONCLASSTYPE_ID = Int_Value
	JOIN ATTRIBUTETYPE ON ATT_TYPE_ID = ATTTYPE_ID_R
	LEFT JOIN ATTRIBUTE ON ATT_ID = ATTRIBUTE_ID_R
	Where FINDINGTYPE_ID_R = @FindingType_ID AND FI_FINDING_ATTRIBUTE.ATTTYPE_ID_R = @AttType_ID_ComplianceDomain
	--Select * From #ComplianceDomain

	--Date Open
	Select YValue, MValue, Sum(USR) DOScore, RANK () Over (Partition By Domain Order by YValue, MValue) ID,Domain INTO #Score_DateOpen From (
	Select Domain, #DateOpen.FindingID, Year(DO) YValue , Month(DO) MValue , #USeverityRisk.USR 
	From #DateOpen
	Join #USeverityRisk on #DateOpen.FindingID = #USeverityRisk.FindingID
	JOIN #ComplianceDomain ON #ComplianceDomain.FindingID = #USeverityRisk.FindingID
	)A
	Group By YValue,MValue,Domain

	--Select * From #Score_DateOpen
	--Required Closure Date
	Select YValue, MValue, Sum(USR) RCScore, RANK () Over (Partition By Domain Order by YValue, MValue) ID,Domain INTO #Score_RClosureDate From (
	Select #ComplianceDomain.Domain, #RClosureDate.FindingID, Year(RCD) YValue , Month(RCD) MValue , #USeverityRisk.USR From #RClosureDate
	Join #USeverityRisk on #RClosureDate.FindingID = #USeverityRisk.FindingID
	JOIN #ComplianceDomain ON #ComplianceDomain.FindingID = #USeverityRisk.FindingID
	)A
	Group By YValue,MValue,Domain

	--Select * From #Score_RClosureDate


	Create Table #FinalScore
	 (
	  FinalID Int Identity,	DateValue Nvarchar(50), Opened Int, Closed Int, Score Int,[Compliance Domains] Varchar(100)
	 )

	 Declare @Count Int =1 ,@Domain Varchar(100), @Total Int , @CurrentRCScore Int, @CurrentACScore Int, @RequestScore Int, @ActualScore Int, @Month Int, @Open Int, @Year Int, @CD Nvarchar(100)
	 Declare @MinMonth Int , @MaxMonth Int , @CurrentScore Int, @RCCountRow Int = 1, @DOCountRow Int = 1
	 --Temp table to loop for all the DoaminType
	 Create Table #ComplianceDomainType
	 (
	  CID Int Identity, [Compliance Domains] Varchar(100))
		Insert Into #ComplianceDomainType
		Select Domain From #Score_DateOpen  
		Union 
		Select Domain From #Score_RClosureDate 

	 Set @Total = @@ROWCOUNT

	 --Select * From #ComplianceDomainType
	 While @Count <= @Total
	BEGIN
	  --Get the Current score from the Date Opened table
	 Select @CD = [Compliance Domains] From #ComplianceDomainType Where CID = @Count
 		Set @Open = 0
		Set @RequestScore = 0
		Set @Domain = ''
		Set @CurrentRCScore = 0 
		Set @RCCountRow = 1 --RowID to select REquiredClosrer Date Score
		Set @DOCountRow = 2 --RowID to select Open Date Score
	
		Select @MinMonth = Min(MValue) From #Score_DateOpen Where Domain = @CD
		Select @MaxMonth = Max(MValue) From #Score_RClosureDate Where Domain = @CD
		 --Select @CurrentACScore = Score From #FinalScore Where FinalID = @Count And [Compliance Domains] = @CD
		 Insert Into #FinalScore
			Select CONVERT(VARCHAR,YVALUE) + ' -(' + CONVERT(VARCHAR,MVALUE) + ')' + DATENAME(MM,DATEADD(MM,MVALUE,-1)),  DOScore,0,DOScore,Domain From #Score_DateOpen 
			Where ID = 1 And Domain = @CD
		 While @MinMonth < @MaxMonth
		 BEGIN
			Set @Year = NULL
			Set @Month = Null
			Set @RequestScore = 0
			Set @Open = 0
			--Calculating the Current Score for the Give Domain
			-- Max(FinalID) to select the last value in the Final Score Table
			Select @CurrentRCScore = Score From #FinalScore Where FinalID = (Select Max(FinalID) From #FinalScore) And [Compliance Domains] = @CD
			Select @RequestScore = RCScore, @Year = YValue, @Month = MValue, @Domain = Domain From #Score_RClosureDate Where ID = @RCCountRow And Domain = @CD And MValue = @MinMonth+1
			--If any value foudn for the given month then only incrementing the counter
			IF @@ROWCOUNT > 0
				Set @RCCountRow = @RCCountRow + 1
			--If There is no Severity found which is being Closed then pick the open Month and Year
			IF @Year IS NULL And @Month IS NULL
				Select @Open = ISNULL(DOScore,0), @Year = YValue, @Month = MValue, @Domain = Domain From #Score_DateOpen Where ID = @DOCountRow And Domain = @CD And MValue = @MinMonth
			ELSE
				Select @Open = ISNULL(DOScore,0) From #Score_DateOpen Where ID = @DOCountRow And Domain = @CD And MValue = @MinMonth
			IF @@ROWCOUNT > 0
				Set @DOCountRow = @DOCountRow + 1
			IF @Month IS NULL
			BEGIN
				Set @Year = 2017
				Set @Month = @MinMonth+1
				Set @RequestScore = 0
				Set @Open =0
			END
			Insert Into #FinalScore Values (CONVERT(VARCHAR,@Year) + ' -(' + CONVERT(VARCHAR,@Month) + ')' + DATENAME(MM,DATEADD(MM,@Month,-1)) ,@Open,@RequestScore,(@CurrentRCScore+@Open-@RequestScore),@CD)
		
			Set @MinMonth = @MinMonth + 1
		END
		Set @Count = @Count + 1
	END

	 Select FinalID, DateValue,Opened,Closed,Score,[Compliance Domains]  From #FinalScore 



	drop table #RClosureDate
	drop table #USeverityRisk
	drop table #ComplianceDomain
	drop table #DateOpen
	drop table #Score_RClosureDate
	drop table #ComplianceDomainType
	drop table #Score_DateOpen
	drop table #FinalScore
END

GO 
GRANT EXEC ON reportdata_QS_FINDING_BURNDOWN_COMPLIANCE_DOMAINTYPE TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'reportdata_QS_FINDING_BURNDOWN_Multiple' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportdata_QS_FINDING_BURNDOWN_Multiple]
GO
CREATE PROC [dbo].[reportdata_QS_FINDING_BURNDOWN_Multiple]
(
@i_sObjectID varchar(max),
@i_sUserID Varchar(100),
@i_sSearch_RSAM_ID varchar(50)

)
AS
BEGIN

	Declare @AttType_ID_ReqyuredClouserDate Int,
			@AttType_ID_UniversalSeverityRisk Int,
			@AttType_ID_DateOpened Int,
			@AttType_ID_ActualClouserDate Int,
			@FindingType_ID Int,
			@AttType_RSAM_ID_RequiredClouserDate Varchar(50)= 'RSAM01-00000742-EE4D4019D54049D4B13F22B4BAA1F112',
			@AttType_RSAM_ID_UniversalSeverityRisk Varchar(50)='RSAM-00209',
			@AttType_RSAM_ID_DateOpened Varchar(50)='RSAM-00620',
			@AttType_RSAM_ID_ActualClouserDate Varchar(50)='RSAM01-00000859-5BF437B693464319A207E1DF6833A602',
			@FindingType_RSAM_ID Varchar(50) ='RSAM-00001'
	Declare @RYear Int, @RMonth Int, @NoRCDateScore Int, @DateScoreOpen_ID Int
	Select @AttType_ID_ReqyuredClouserDate = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = @AttType_RSAM_ID_RequiredClouserDate
	Select @AttType_ID_ActualClouserDate = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = @AttType_RSAM_ID_ActualClouserDate
	Select @AttType_ID_DateOpened = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = @AttType_RSAM_ID_DateOpened
	Select @AttType_ID_UniversalSeverityRisk = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = @AttType_RSAM_ID_UniversalSeverityRisk
	Select @FindingType_ID = FINDINGTYPE_ID FROM FI_FINDINGTYPE WHERE FINDINGTYPE_RSAM_ID = @FindingType_RSAM_ID

	Select Position, Int_Value INTO #OBJ From dbo.FnConvertStrToArray(@i_sObjectID,',')

	Create Table #RClosureDate (FindingID Int, ColName Varchar(100), RCD Date)
	Create Table #USeverityRisk (FindingID Int, ColName Varchar(100), USR Int)
	Create Table #AClosureDate (FindingID Int, ColName Varchar(100), ACD Date)
	Create Table #DateOpen (FindingID Int, ColName Varchar(100), DO Date)
	
	Declare @i_SearchID Int
	Select @i_SearchID = Search_ID From Search Where Search_RSAM_ID = @i_sSearch_RSAM_ID
	CREATE TABLE #Search_Mid          
	( Item_ID int) 
	Insert Into #Search_Mid (Item_ID)
	exec RS_SavedSearch @i_SearchID,@i_sUserID = @i_sUserID,@i_bIgnorePermissions=N'0',@i_iGetDataOnlyForFirstColumn = 1,@i_sFieldsToDisplay = ''

	Select FINDING_ID,OBJ_ID_R INTO #Search From #Search_Mid
	JOIN FI_FINDING ON Item_ID = FINDING_ID And FINDINGTYPE_ID_R = @FindingType_ID -- Filtering for only Questionnaire FIndings
	JOIN #OBJ ON Int_Value = OBJ_ID_R

	Insert Into #USeverityRisk
	Select FINDING_ID, ATTTYPE_NAME, convert(varchar,ATT_WEIGHT) ATTRIBUTE_DATA 
	From #Search 
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R And FI_FINDING_ATTRIBUTE.ATTTYPE_ID_R = @AttType_ID_UniversalSeverityRisk
	JOIN ATTRIBUTETYPE ON ATT_TYPE_ID = ATTTYPE_ID_R
	LEFT JOIN ATTRIBUTE ON ATT_ID = ATTRIBUTE_ID_R
	
	--sELECT * fROM #USeverityRisk
	Insert Into #DateOpen
	Select FINDING_ID, ATTTYPE_NAME, ATTRIBUTE_DATE 
	From #Search 
	
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R
	JOIN ATTRIBUTETYPE ON ATT_TYPE_ID = ATTTYPE_ID_R
	Where FI_FINDING_ATTRIBUTE.ATTTYPE_ID_R = @AttType_ID_DateOpened --OBJ_ID_R = @i_iObjectID And

	Insert Into #RClosureDate
	Select FINDING_ID, ATTTYPE_NAME, ATTRIBUTE_DATE From #Search 
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R
	JOIN ATTRIBUTETYPE ON ATT_TYPE_ID = ATTTYPE_ID_R
	Where FI_FINDING_ATTRIBUTE.ATTTYPE_ID_R = @AttType_ID_ReqyuredClouserDate
	--sELECT * FROM #RClosureDate
	Insert Into #AClosureDate
	Select FINDING_ID, ATTTYPE_NAME, ATTRIBUTE_DATE From #Search
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R
	JOIN ATTRIBUTETYPE ON ATT_TYPE_ID = ATTTYPE_ID_R
	LEFT JOIN ATTRIBUTE ON ATT_ID = ATTRIBUTE_ID_R
	Where FI_FINDING_ATTRIBUTE.ATTTYPE_ID_R = @AttType_ID_ActualClouserDate

	--Date Open
	Select YValue, MValue, Sum(USR) DOScore, RANK () Over (Order by YValue, MValue) ID INTO #Score_DateOpen From (
	Select #DateOpen.FindingID, Year(DO) YValue , Month(DO) MValue , #USeverityRisk.USR 
	From #DateOpen
	Join #USeverityRisk on #DateOpen.FindingID = #USeverityRisk.FindingID
	)A
	Group By YValue,MValue

	Select YValue, MValue, Sum(USR) RCScore INTO #Temp From (
	Select #RClosureDate.FindingID, Year(RCD) YValue , Month(RCD) MValue , ISNULL(#USeverityRisk.USR,0) USR From #RClosureDate
	Left Join #USeverityRisk on #RClosureDate.FindingID = #USeverityRisk.FindingID
	)A
	Group By YValue,MValue

	IF EXISTS (Select 1 From #Temp Where YValue IS NULL And MValue IS NULL)
		BEGIN
			SELECT @RMonth = MAX(MVALUE) FROM #Temp
			SELECT @RYear = MAX(YValue) FROM #Temp
			IF @RMonth = 12
			BEGIN
				SET @RYear = @RYear + 1
				SET @RMonth = 1
			END
			Select @NoRCDateScore = Sum(RCScore) From #Temp Where YValue IS NULL And MValue IS NULL
			
			UPDATE #Temp SET MValue = @RMonth, YValue = @RYear Where YValue IS NULL And MValue IS NULL
		END

	--Required Closure Date
	Select YValue, MValue, Sum(RCScore) RCScore, RANK () Over (Order by YValue, MValue) ID INTO #Score_RClosureDate From #Temp 
	Group By YValue,MValue

	--Actual Closure Date
	Select YValue, MValue, Sum(USR) ACScore, RANK () Over (Order by YValue, MValue) ID INTO #Score_AClosureDate From (
	Select #AClosureDate.FindingID, Year(ACD) YValue , Month(ACD) MValue , #USeverityRisk.USR 
	From #AClosureDate
	Join #USeverityRisk on #AClosureDate.FindingID = #USeverityRisk.FindingID
	)A
	Group By YValue,MValue

	--Select * From #Score_RClosureDate
	--Select * From #Score_AClosureDate
	--Select * From #Score_DateOpen

	Create Table #FinalScore
	 (
	  FinalID Int Identity,	DateValue Nvarchar(50), Opened Int, Closed Int, Target Int,Actual Int)
 
	 --Get the Current score from the Date Opened table
	 Insert Into #FinalScore
	 Select CONVERT(VARCHAR,YVALUE) + ' -(' + CONVERT(VARCHAR,MVALUE) + ')' + DATENAME(MM,DATEADD(MM,MVALUE,-1)),  DOScore,0,DOScore,DOScore From #Score_DateOpen 
	 Where ID = 1

	 Declare @Count Int =1 , @TotalCount Int , @CurrentRCScore Int, @CurrentACScore Int, @RequestScore Int, @ActualScore Int, @Month Int, @Open Int, @Year Int
	 Select @TotalCount = Max(ID) From #Score_RClosureDate

	 While @TotalCount >= @Count
	 BEGIN
		Set @Open = 0
		Set @RequestScore = 0
		Set @ActualScore = 0

		Select @CurrentRCScore = Target From #FinalScore Where FinalID = @Count -- Get the Current Score for Required Closure Date
		Select @CurrentACScore = Actual From #FinalScore Where FinalID = @Count -- Get the Current Score for Actual Closure Date

		Select @Month=MValue, @RequestScore = RCScore From #Score_RClosureDate Where ID = @Count
		
		Select @ActualScore = ACScore, @Year = YValue, @Month = MValue From #Score_AClosureDate Where ID = @Count
		
		Set @Count = @Count + 1
		--If There is no Severity found which is being Closed then pick the open Month and Year
		IF @Year IS NULL And @Month IS NULL
			Select @Open = ISNULL(DOScore,0), @Year = YValue, @Month = MValue From #Score_DateOpen Where ID = @Count
		ELSE
			Select @Open = ISNULL(DOScore,0) From #Score_DateOpen Where ID = @Count
		
		IF @Year = @RYear And @Month = @RMonth	
			Set @Open = @Open + @NoRCDateScore
		IF @Year = YEAR(GETDATE()) aND @Month > MONTH(GETDATE())
			Insert Into #FinalScore Values (CONVERT(VARCHAR,@Year) + ' -(' + CONVERT(VARCHAR,@Month) + ')' + DATENAME(MM,DATEADD(MM,@Month,-1)) ,@Open,@RequestScore,(@CurrentRCScore+@Open-@RequestScore),NULL)
		ELSE
			Insert Into #FinalScore Values (CONVERT(VARCHAR,@Year) + ' -(' + CONVERT(VARCHAR,@Month) + ')' + DATENAME(MM,DATEADD(MM,@Month,-1)) ,@Open,@RequestScore,(@CurrentRCScore+@Open-@RequestScore),abs(@CurrentACScore+@Open-@ActualScore))
	END

	 Select * From #FinalScore


	drop table #RClosureDate
	drop table #USeverityRisk
	drop table #AClosureDate
	drop table #DateOpen
	drop table #Score_RClosureDate
	drop table #Score_AClosureDate
	drop table #Score_DateOpen
	drop table #FinalScore
	drop table #Temp
	drop table #OBJ
	drop table #Search
	drop table #Search_Mid
END

GO 
GRANT EXEC ON reportdata_QS_FINDING_BURNDOWN_Multiple TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'reportdata_RiskFactor_Summary' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportdata_RiskFactor_Summary]
GO
CREATE PROC [dbo].[reportdata_RiskFactor_Summary] 
(
	@i_iObjectID Int,
	@i_sSearch_RSAM_ID varchar(50),
	@i_sUserID Varchar(100),
	@i_sFindingTypeID varchar(500)	
)
AS
--Declare @i_iObjectID INT = 9388
--Declare @i_sSearch_RSAM_ID varchar(50) = 'RSAMA6-00003949-59E1FE03F3914BE1BC55300A46903C55'
--Declare @i_sFindingTypeID varchar(500) = 1

	Declare @i_SearchID Int, @US_iAtt_Type_ID Int, @AS_iAtt_Type_ID Int, @OC_iAtt_Type_ID Int, @OC_ATT_ID Int
	Select @i_SearchID = Search_ID From Search Where Search_RSAM_ID = @i_sSearch_RSAM_ID
	Select @US_iAtt_Type_ID = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = 'RSAM-00209'
	Select @AS_iAtt_Type_ID = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = 'RSAM01-00000860-D3F4EF2599D9448DA6E54ACFAE1B42DB' -- Alert Status
	Select @OC_iAtt_Type_ID = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = 'RSAM01-00000861-033032A0D51F4743A243FBA49B4B70C2' --Open/Close
	Select @OC_ATT_ID = ATT_ID From ATTRIBUTE Where ATT_RSAM_ID = 'RSAM01-00000934-2F6F8200E0944E9DACB557BCB44E2A5D' --Open/Close Att_ID 
	--Ex
	CREATE TABLE #Search          
	( Item_ID int,Record_Type NVARCHAR(200) NULL,UniversalSeverity_Risk NVARCHAR(50)  NULL, Open_Close NVARCHAR(10) NULL, AlertStatus NVARCHAR(20) NULL) 
	Insert Into #Search (Item_ID)
	exec RS_SavedSearch @i_iSearchID= @i_SearchID,@i_sUserID= @i_suserID,@i_bIgnorePermissions=N'0',@i_iGetDataOnlyForFirstColumn = 1,@i_sFieldsToDisplay = ''

	
	Update #Search Set Record_Type = FINDINGTYPE_NAME From #Search 
	JOIN FI_FINDING ON FINDING_ID = Item_ID
	JOIN FI_FINDINGTYPE ON FINDINGTYPE_ID = FINDINGTYPE_ID_R

	Update #Search Set UniversalSeverity_Risk = ATT_DESC From #Search 
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID_R = Item_ID And ATTTYPE_ID_R = @US_iAtt_Type_ID
	Left JOIN ATTRIBUTE ON ATT_ID = ATTRIBUTE_ID_R

	Update #Search Set AlertStatus = ATT_DESC From #Search 
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID_R = Item_ID And ATTTYPE_ID_R = @AS_iAtt_Type_ID
	LEFT JOIN ATTRIBUTE ON ATT_ID = ATTRIBUTE_ID_R

	Update #Search Set Open_Close = ATT_DESC From #Search 
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID_R = Item_ID And ATTTYPE_ID_R = @OC_iAtt_Type_ID
	LEFT JOIN ATTRIBUTE ON ATT_ID = ATTRIBUTE_ID_R
	
	
	Select Int_Value INTO #FType From dbo.FnConvertStrToArray(@i_sFindingTypeID , ',')

	--Geting the Findings which is in Open State 
	Select FINDINGTYPE_NAME,FINDING_ID INTO #Open_Findings From FI_FINDING
	JOIN #FType ON Int_Value = FINDINGTYPE_ID_R
	JOIN FI_FINDINGTYPE ON FINDINGTYPE_ID = FINDINGTYPE_ID_R
	JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID = FINDING_ID_R And ATTTYPE_ID_R = @OC_iAtt_Type_ID And ATTRIBUTE_ID_R = @OC_ATT_ID
	Where OBJ_ID_R = @i_iObjectID


	Select Record_Type FINDINGTYPE_NAME,Sum(ATT_WEIGHT) Total_Universal_Severity,Max(AlertStatus) Highest_Alert_Status,Count(#Search.Item_ID) [Count] ,Max(UniversalSeverity_Risk) Highest_Universal_Severity
	From #Search 
	JOIN #Open_Findings ON FINDING_ID = Item_ID
	LEFT JOIN FI_FINDING_ATTRIBUTE ON FINDING_ID_R = #Search.Item_ID  And ATTTYPE_ID_R = @US_iAtt_Type_ID
	LEFT JOIN ATTRIBUTE ON ATT_ID = ATTRIBUTE_ID_R And ATTRIBUTE.ATTTYPE_ID_R = @US_iAtt_Type_ID 
	Group By Record_Type

	Drop table #Search
	Drop Table #FType
	Drop Table #Open_Findings


GO 
GRANT EXEC ON reportdata_RiskFactor_Summary TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'reportdata_StackedChart' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportdata_StackedChart]
GO
CREATE PROC [dbo].[reportdata_StackedChart]
(
	@i_iObjectID INT,
	@i_sSearch_RSAM_ID varchar(50),
	@i_sUserID Varchar(100),
	@i_sFindingTypeID varchar(500)
)
AS
--Declare @i_iObjectID INT = 9388
--Declare @i_sSearch_RSAM_ID varchar(50) = 'RSAMA6-00003949-59E1FE03F3914BE1BC55300A46903C55'
--Declare @i_sFindingTypeID varchar(500) = 1
	
	DECLARE @ATT_ID_LOCAL INT
	Declare @AttType_RSAM_ID_UniversalSeverityRisk Varchar(50)='RSAM-00209',@AttType_ID_UniversalSeverityRisk INT

	--SELECT @ATT_ID_LOCAL = ATT_ID FROM ATTRIBUTE WHERE ATT_RSAM_ID = 'RSAM01-00000148-D4F60E8730BB405C805261A703CF00E3'
	Select @AttType_ID_UniversalSeverityRisk = ATT_TYPE_ID From ATTRIBUTETYPE Where ATTTYPE_RSAM_ID = @AttType_RSAM_ID_UniversalSeverityRisk
	Declare @i_SearchID Int
	Select @i_SearchID = Search_ID From Search Where Search_RSAM_ID = @i_sSearch_RSAM_ID
	
	CREATE TABLE #Search          
	( Item_ID int,Record_Type NVarchar(200) NULL,WorkFlow_State NVarchar(200) NULL) 
	Insert Into #Search (Item_ID)
	exec RS_SavedSearch @i_iSearchID= @i_SearchID,@i_sUserID= @i_sUserID,@i_bIgnorePermissions=N'0',@i_iGetDataOnlyForFirstColumn = 1,@i_sFieldsToDisplay = ''

	Update #Search Set Record_Type = FINDINGTYPE_NAME From #Search 
	JOIN FI_FINDING ON FINDING_ID = Item_ID
	JOIN FI_FINDINGTYPE ON FINDINGTYPE_ID = FINDINGTYPE_ID_R

	Update #Search Set WorkFlow_State = WF_STATE_NAME From #Search 
	JOIN FI_FINDING ON FINDING_ID = Item_ID
	JOIN SYS_WF_STATE ON WF_STATE_ID = FINDING_WF_STATE_ID_R

	Select Int_Value INTO #FType From dbo.FnConvertStrToArray(@i_sFindingTypeID , ',')

	Select FI_FINDING.FINDING_ID, WorkFlow_State WF_STATE_NAME,Record_Type FINDINGTYPE_NAME, ISNULL(ATT_WEIGHT,0) ATT_WEIGHT
	From FI_FINDING 
	JOIN #Search ON #Search.Item_ID = FI_FINDING.FINDING_ID
	JOIN #FType ON #FType.Int_Value = FINDINGTYPE_ID_R
	LEFT JOIN FI_FINDING_ATTRIBUTE FA ON FI_FINDING.FINDING_ID = FA.FINDING_ID_R And FA.ATTTYPE_ID_R = @AttType_ID_UniversalSeverityRisk
	LEFT JOIN ATTRIBUTE on ATT_ID = FA.ATTRIBUTE_ID_R 
	Where OBJ_ID_R  = @i_iObjectID

	Drop Table #Search
	Drop Table #FType

GO 
GRANT EXEC ON reportdata_StackedChart TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'reportdata_sub_object_special_policies' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportdata_sub_object_special_policies]
GO

CREATE PROCEDURE [dbo].[reportdata_sub_object_special_policies]            
(            
 @RMTYPE int,            
 @mode char(1),            
 @CTypeSQL bigint,            
 @ItemID bigint,            
 @rlkey bigint,                
 @rtypekey bigint,        
 @RptID bigint              
)            
AS            
BEGIN
 SET NOCOUNT ON;
 
 if @rlkey = 0               
  set @rlkey =null              
 if @rtypekey =0               
  set @rtypekey =null              
  
  --To run reports based on Aspect objects      
  declare @obj_Aspect_link int      
  declare @OldItemID int      
        
  set @OldItemID = @ItemID      
  set @obj_Aspect_link=(select obj_aspect_link from object where obj_id=@ItemID)            
      
  --Assign the main object ID to the Aspect object  
  if @mode='O'  
   BEGIN    
    if @obj_Aspect_link <> @ItemID      
    BEGIN      
      set @ItemID=@obj_Aspect_link      
    END           
   END              
            
  CREATE TABLE #TmpObjFilter(OBJ_ID int,         
  OBJ_NAME nvarchar(1000),OBJ_DESC nvarchar(max), OBJTYPE_ID_R int,OBJ_GROUP_R int,        
  OBJ_INOTES nvarchar(max), OBJ_RNOTES nvarchar(max),OBJ_AUDITCOMP bit,        
  OBJ_REVIEWCOMP bit, OBJ_LOCKED bit,OBJ_DOE smalldatetime,        
  OBJ_EB nvarchar(500),OBJ_DOU datetime,        
  OBJ_UB nvarchar(500), OBJ_GROUP_LINK int,OBJ_ASPECT_LINK int,        
  OBJ_WF_STATE_ID_R int,OBJ_CYCLE_DATE datetime,ASPECT_CONTAINERTYPE int,        
  WF_STATE_NAME nvarchar(500),WF_STATE_EXCLUDE_FROM_REPORTS int,        
  WF_STATE_VIEW_RISKMANAGEMENT int,ASPECT_OBJTYPE_ID int)                                     
            
 INSERT INTO #TmpObjFilter SELECT OBJ_ID,OBJ_NAME,OBJ_DESC,                                          
  OBJTYPE_ID_R,OBJ_GROUP_R,OBJ_INOTES,OBJ_RNOTES,                                          
  OBJ_AUDITCOMP,OBJ_REVIEWCOMP,OBJ_LOCKED,                                          
  OBJ_DOE,OBJ_EB,OBJ_DOU,OBJ_UB,OBJ_GROUP_LINK,                                          
  OBJ_ASPECT_LINK,OBJ_WF_STATE_ID_R,OBJ_CYCLE_DATE,ASPECT_CONTAINERTYPE,              
  WF_STATE_NAME,WF_STATE_EXCLUDE_FROM_REPORTS,WF_STATE_VIEW_RISKMANAGEMENT,              
  ASPECT_OBJTYPE_ID                 
  FROM dbo.fn_OBJECT_FILTER(@mode,@CTypeSQL,@Itemid,@RptID,0)               
      
 --New tables added for Score change (Inherit criticality from Entities)  
 --Table #1. #R_Object_SpecialPolicy_Prep_CON  
 --Table #2. #R_Object_SpecialPolicy_Prep_RF  
   
 --R_Object_SpecialPolicy_Prep_CON  
 CREATE TABLE #R_Object_SpecialPolicy_Prep_CON  
 (OBJ_ID int,RISKTYPE_ID_R int,MaxOfRL_RATING int)  
  
 INSERT INTO #R_Object_SpecialPolicy_Prep_CON  
 SELECT REPORT_OBJECT.OBJ_ID, RISKLEVEL.RISKTYPE_ID_R,   
 Max(RISKLEVEL.RL_RATING) AS MaxOfRL_RATING  
 FROM (((#TmpObjFilter AS REPORT_OBJECT INNER JOIN   
 (#TmpObjFilter AS MAIN_OBJECT INNER JOIN #TmpObjFilter   
 AS ASPECT_OBJECT ON MAIN_OBJECT.OBJ_ID = ASPECT_OBJECT.OBJ_ASPECT_LINK)   
 ON REPORT_OBJECT.OBJ_ASPECT_LINK = MAIN_OBJECT.OBJ_ID)   
 INNER JOIN OBJECTTYPE ON REPORT_OBJECT.OBJTYPE_ID_R = OBJECTTYPE.OBJTYPE_ID)   
 INNER JOIN (OBJECT_CONTROL INNER JOIN CONTROL_RISKLEVEL   
 ON OBJECT_CONTROL.CON_ID_R = CONTROL_RISKLEVEL.CON_ID_R)   
 ON ASPECT_OBJECT.OBJ_ID = OBJECT_CONTROL.OBJ_ID_R)   
 INNER JOIN RISKLEVEL ON CONTROL_RISKLEVEL.RL_ID_R = RISKLEVEL.RL_ID  
 GROUP BY REPORT_OBJECT.OBJ_ID, RISKLEVEL.RISKTYPE_ID_R, ASPECT_OBJECT.OBJ_ID,   
 OBJECTTYPE.OBJTYPE_ASPECT_INHERIT_CRITICALITY  
 HAVING (((ASPECT_OBJECT.OBJ_ID)=REPORT_OBJECT.OBJ_ID)) OR  
 (((OBJECTTYPE.OBJTYPE_ASPECT_INHERIT_CRITICALITY)=1))  
   
 --R_Object_SpecialPolicy_Prep_RF  
 CREATE TABLE #R_Object_SpecialPolicy_Prep_RF  
 (OBJ_ID int,RISKTYPE_ID_R int,MaxOfRL_RATING int)  
  
 INSERT INTO #R_Object_SpecialPolicy_Prep_RF  
 SELECT REPORT_OBJECT.OBJ_ID, RISKLEVEL.RISKTYPE_ID_R,   
 Max(RISKLEVEL.RL_RATING) AS MaxOfRL_RATING  
 FROM (#TmpObjFilter AS REPORT_OBJECT INNER JOIN (#TmpObjFilter   
 AS MAIN_OBJECT INNER JOIN (RISKLEVEL INNER JOIN ((#TmpObjFilter   
 AS ASPECT_OBJECT INNER JOIN OBJ_RF_ALL_ENTITIES ON   
 ASPECT_OBJECT.OBJ_ID = OBJ_RF_ALL_ENTITIES.OBJ_ID_R)   
 INNER JOIN RISKFACTOR_POLICY ON   
 OBJ_RF_ALL_ENTITIES.RF_ID_R = RISKFACTOR_POLICY.RF_ID_R)   
 ON RISKLEVEL.RL_ID = RISKFACTOR_POLICY.RL_ID_R)   
 ON MAIN_OBJECT.OBJ_ID = ASPECT_OBJECT.OBJ_ASPECT_LINK)   
 ON REPORT_OBJECT.OBJ_ASPECT_LINK = MAIN_OBJECT.OBJ_ID)   
 INNER JOIN OBJECTTYPE ON REPORT_OBJECT.OBJTYPE_ID_R = OBJECTTYPE.OBJTYPE_ID  
 GROUP BY REPORT_OBJECT.OBJ_ID, RISKLEVEL.RISKTYPE_ID_R,   
 ASPECT_OBJECT.OBJ_ID, OBJECTTYPE.OBJTYPE_ASPECT_INHERIT_CRITICALITY  
 HAVING (((ASPECT_OBJECT.OBJ_ID)=REPORT_OBJECT.OBJ_ID))   
 OR (((OBJECTTYPE.OBJTYPE_ASPECT_INHERIT_CRITICALITY)=1))  
  
 --Existing Query updated to incorporate score changes (Inherit criticality from Entities)  
 --Previous Query commented  
 CREATE TABLE #R_Object_Special_Policy_Prep(OBJ_ID int,RISKTYPE_ID_R int,    
 MaxOfRL_RATING int)     
  
 INSERT INTO #R_Object_Special_Policy_Prep  
 SELECT * FROM #R_Object_SpecialPolicy_Prep_RF  
 UNION SELECT * FROM #R_Object_SpecialPolicy_Prep_CON         
   
            
 SELECT #R_Object_Special_Policy_Prep.OBJ_ID,             
 RISKLEVEL.RL_NAME, RISKLEVEL.RL_WEIGHT, 0 AS POLICY_SEC,             
 0 AS POLICY_AVAIL, RISKLEVEL.RL_CODE, RISKLEVEL.RL_SYMBOL,             
 RISKTYPE.RISKTYPE_NAME            
 FROM (#R_Object_Special_Policy_Prep LEFT JOIN RISKLEVEL ON             
 (#R_Object_Special_Policy_Prep.MaxOfRL_RATING = RISKLEVEL.RL_RATING) AND             
 (#R_Object_Special_Policy_Prep.RISKTYPE_ID_R = RISKLEVEL.RISKTYPE_ID_R))             
 LEFT JOIN RISKTYPE ON RISKLEVEL.RISKTYPE_ID_R = RISKTYPE.RISKTYPE_ID            
 GROUP BY #R_Object_Special_Policy_Prep.OBJ_ID, RISKLEVEL.RL_NAME,             
 RISKLEVEL.RL_WEIGHT, RISKLEVEL.RL_CODE, RISKLEVEL.RL_SYMBOL,             
 RISKTYPE.RISKTYPE_NAME, RISKLEVEL.RL_ID, RISKTYPE.RISKTYPE_ID            
 Having ((RISKLEVEL.RL_ID)= (Select Case              
                               WHEN  @rlkey Is Null Then RISKLEVEL.RL_ID              
                             else  @rlkey END))              
 AND              
 ((RISKTYPE.RISKTYPE_ID)=(Select Case              
                               WHEN @rtypekey Is Null Then RISKTYPE.RISKTYPE_ID              
                               else @rtypekey END))    
 AND
 (#R_Object_Special_Policy_Prep.OBJ_ID =  
 (case   
  WHEN  (@mode <>'O') THEN #R_Object_Special_Policy_Prep.OBJ_ID   
  WHEN  (@mode ='O' and @OldItemID = @obj_Aspect_link) THEN #R_Object_Special_Policy_Prep.OBJ_ID      
  ELSE  @OldItemID              
  END))                       

END


GO 
GRANT EXEC ON reportdata_sub_object_special_policies TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'reportparam_DomainTYpe' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportparam_DomainTYpe]
GO
CREATE PROC [dbo].[reportparam_DomainTYpe]-- 9503
( 
	@i_iObjectID varchar(max)
)
AS
BEGIN
	--Declare @i_iObjectID Int = 9503
	Select Position, Int_Value INTO #Temp From dbo.FnConvertStrToArray(@i_iObjectID,',')
	Select Distinct OBJTYPE_ID_R INTO #OBJ From Object
	JOIN #Temp ON #Temp.Int_Value = OBJ_ASPECT_LINK 

Select Distinct CONCLASSTYPE_ID, CONCLASSTYPE_NAME INTO #DomainType From CONTROLCLASS 
JOIN CONTROLCLASSTYPE ON  CONCLASSTYPE_ID = CONCLASSTYPE_ID_R
JOIN CONTROLTYPE_CONTROLCLASS ON CONCLASS_ID = CONCLASS_ID_R
JOIN OBJECTTYPE_CONTROLTYPE ON OBJECTTYPE_CONTROLTYPE.CONTYPE_ID_R = CONTROLTYPE_CONTROLCLASS.CONTYPE_ID_R
JOIN #OBJ ON #OBJ.OBJTYPE_ID_R = OBJECTTYPE_CONTROLTYPE.OBJTYPE_ID_R
Order by 2

IF @@ROWCOUNT > 0
	Select CONCLASSTYPE_ID, CONCLASSTYPE_NAME From #DomainType 
Else
	Select 0 CONCLASSTYPE_ID, 'No Domain Type' CONCLASSTYPE_NAME
END


GO 
GRANT EXEC ON reportparam_DomainTYpe TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'reportParam_FindingType' AND Type = 'P')
	DROP PROCEDURE [dbo].[reportParam_FindingType]
GO
CREATE PROC [dbo].[reportParam_FindingType]
(
	@i_sSearch_RSAM_ID varchar(50)
)
AS
BEGIN
	Declare @i_SearchID Int, @sFindingType Varchar(500)
	Select @i_SearchID = Search_ID From Search Where Search_RSAM_ID = @i_sSearch_RSAM_ID
	
	Select @sFindingType = FILTER From SEARCH_SELECTION where SEARCH_ID_R = @i_SearchID And FIELD_ID = 12
	Select Int_Value INTO #FType From dbo.FnConvertStrToArray(@sFindingType , '')
	
	SELECT FINDINGTYPE_ID, FINDINGTYPE_NAME FROM 
	FI_FINDINGTYPE
	JOIN #FType ON FINDINGTYPE_ID = Int_Value
	Order by 2
END

GO 
GRANT EXEC ON reportParam_FindingType TO RSAM_CLIENT
